// ~~ Generated by Modular Boilerplate ~~
import { h, render } from 'preact';
import tuiFonts from '@tui/ui-library/scss/themes/tui/fonts.json';
import tuiLightFonts from '@tui/ui-library/scss/themes/tui-light/fonts.json';
import lturFonts from '@tui/ui-library/scss/themes/ltur/fonts.json';
import { App } from './App';
import { MFE_TAG_NAME, WebComponentAttributes } from './constants';
import { AppAttributeProps } from './types';
import { getAttributes, prepareAttribute } from './attributes';

declare type FontDisplay = 'auto' | 'block' | 'swap' | 'fallback' | 'optional';

const webComponentAttrToAppAttrName = (
  name: WebComponentAttributes
): keyof AppAttributeProps =>
  name
    .split('-')
    .map((word, index) =>
      index ? word.charAt(0).toUpperCase() + word.slice(1) : word
    )
    .join('') as keyof AppAttributeProps;

export class MFECustomElement extends HTMLElement {
  private attributeProps: AppAttributeProps;

  private dependencyLoading: Promise<unknown>;

  private readonly mainEl: HTMLElementTagNameMap['main'];

  private styleEl: HTMLElementTagNameMap['link'];

  private _renderPromise: Promise<void> | null;

  static get observedAttributes() {
    return [WebComponentAttributes.locale, WebComponentAttributes.market];
  }

  constructor() {
    super();

    this.mainEl = document.createElement('main');
    // In the initial state, the Web Component has a skeleton which must be visible during MFE loading
    this.mainEl.innerHTML = this.innerHTML;
  }

  private waitInteractiveState() {
    return new Promise<void>((resolve) => {
      if (document.readyState === 'loading') {
        document.addEventListener('readystatechange', () => {
          if (document.readyState === 'interactive') {
            resolve();
          }
        });
      } else {
        resolve();
      }
    });
  }

  private async loadFont(theme: string): Promise<void[] | null> {

    const THEME_FONTS: Record<string, typeof tuiFonts> = {
      'tui': tuiFonts,
      'tui-light': tuiLightFonts,
      'ltur': lturFonts,
    };
    
    if (THEME_FONTS[theme]) {
      return Promise.all(THEME_FONTS[theme].map(async (
        { path, display, weight, family, style }:
        { path: string, display: string, weight: string, family: string, style: string }
      ) => {
        const font = new FontFace(
          `${MFE_TAG_NAME}-${family}`,
          `url(${path})`,
          { style, weight, display: <FontDisplay> display }
        );

        const fontface = await font.load();

        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        (<any> document.fonts).add(fontface);
      }));
    } else {
      return Promise.resolve(null);
    }
  }

  private loadStyles(): Promise<void> {
    return new Promise((resolve) => {
      this.styleEl = document.createElement('link');
      this.styleEl.setAttribute('rel', 'stylesheet');
      this.styleEl.setAttribute(
        'href',
        `__MFE_URL__/main-${this.attributeProps.theme}.css`
      );
      this.styleEl.onload = () => resolve();
    });
  }

  private render(): Promise<void> {
    return this.dependencyLoading?.then(() => {
      render(
        h(App, this.attributeProps),
        this.mainEl
      );
    });
  }

  private requestRender(): void {
    if (!this._renderPromise) {
      this._renderPromise = Promise.resolve().then(() => {
        this._renderPromise = null;
        return this.render();
      });
    }
  }

  attributeChangedCallback(
    name: WebComponentAttributes,
    _oldValue: string | null,
    newValue: string | null
  ) {
    if (!this.attributeProps) {
      this.attributeProps = getAttributes(this);
    }

    const propName: keyof AppAttributeProps =
      webComponentAttrToAppAttrName(name);

    this.attributeProps = { ...this.attributeProps, ...prepareAttribute(propName, newValue) };
    
    return this.requestRender();
  }

  connectedCallback() {
    this.attributeProps = getAttributes(this);

    // start loading dependencies and trigger render when all dependencies are load
    this.dependencyLoading = this.waitInteractiveState().then(() =>
      this.requestRender()
    );

    const theme: string = this.attributeProps.theme as string;

    this.dependencyLoading = Promise.all([
      this.loadStyles(),
      this.loadFont(theme),
    ]);

    this.attachShadow({ mode: 'closed' }).append(this.styleEl, this.mainEl);
  }

  disconnectedCallback() {
    return render(null, this.mainEl);
  }
}

customElements.define(MFE_TAG_NAME, MFECustomElement);
